package com.ainirobot.sdk2plugin;

import android.app.Application;
import android.content.Context;
import android.support.multidex.MultiDex;

import com.ainirobot.testsdk.HelloModuleReactPackage;
import com.ainirobot.testsdk2.Test2ReactPackage;
import com.facebook.react.ReactApplication;
import com.facebook.react.ReactNativeHost;
import com.facebook.react.ReactPackage;
import com.facebook.react.shell.MainReactPackage;
import com.facebook.soloader.SoLoader;
import com.swmansion.gesturehandler.react.RNGestureHandlerPackage;
import com.swmansion.reanimated.ReanimatedPackage;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class MainApplication extends Application implements ReactApplication {

    private final ReactNativeHost mReactNativeHost = new ReactNativeHost(this) {
        @Override
        public boolean getUseDeveloperSupport() {
            return BuildConfig.DEBUG;
        }

        @Override
        protected List<ReactPackage> getPackages() {
            List<ReactPackage> packages = new ArrayList<>();
            packages.add(new MainReactPackage());
            packages.add(new RNGestureHandlerPackage());
            packages.add(new ReanimatedPackage());

            // add for test
            packages.add(new HelloModuleReactPackage());
            packages.add(new Test2ReactPackage());
            return packages;
        }

        @Override
        protected String getJSMainModuleName() {
            return "index";
        }
    };

    @Override
    public ReactNativeHost getReactNativeHost() {
        return mReactNativeHost;
    }

    @Override
    public void onCreate() {
        super.onCreate();
        try {
            SoLoader.init(this, SoLoader.SOLOADER_DISABLE_BACKUP_SOSOURCE);
            SoLoader.setSystemLoadLibraryWrapper(libName -> System.loadLibrary(libName));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void attachBaseContext(Context base) {
        super.attachBaseContext(base);
        MultiDex.install(this);
    }
}
